Index: src/sas/qtgui/Perspectives/Corfunc/CorfuncPerspective.py
===================================================================
--- src/sas/qtgui/Perspectives/Corfunc/CorfuncPerspective.py	(revision dee9e5f369951654b0c4ceb6506475a3cd8ed1f9)
+++ src/sas/qtgui/Perspectives/Corfunc/CorfuncPerspective.py	(revision 3beadedeafa5341a55686bd2212947210cb0a4ed)
@@ -7,4 +7,5 @@
 from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg \
     as FigureCanvas
+from matplotlib.backends.backend_qt5agg import NavigationToolbar2QT
 from matplotlib.figure import Figure
 from numpy.linalg.linalg import LinAlgError
@@ -35,4 +36,5 @@
         self.data = None
         self.extrap = None
+        self.setMinimumSize(300, 300)
 
     def draw_q_space(self):
@@ -49,4 +51,8 @@
         self.axes.set_xscale("log")
         self.axes.set_yscale("log")
+        self.axes.set_xlabel("Q [$\AA^{-1}$]")
+        self.axes.set_ylabel("I(Q) [cm$^{-1}$]")
+        self.axes.set_title("Scattering data")
+        self.fig.tight_layout()
 
         qmin = float(self.model.item(W.W_QMIN).text())
@@ -55,5 +61,6 @@
 
         if self.data:
-            self.axes.plot(self.data.x, self.data.y)
+            # self.axes.plot(self.data.x, self.data.y, label="Experimental Data")
+            self.axes.errorbar(self.data.x, self.data.y, yerr=self.data.dy, label="Experimental Data")
             self.axes.axvline(qmin)
             self.axes.axvline(qmax1)
@@ -61,6 +68,12 @@
             self.axes.set_xlim(min(self.data.x) / 2,
                                max(self.data.x) * 1.5 - 0.5 * min(self.data.x))
+            self.axes.set_ylim(min(self.data.y) / 2,
+                               max(self.data.y) * 1.5 - 0.5 * min(self.data.y))
+
         if self.extrap:
-            self.axes.plot(self.extrap.x, self.extrap.y)
+            self.axes.plot(self.extrap.x, self.extrap.y, label="Extrapolation")
+
+        if self.data or self.extrap:
+            self.axes.legend()
 
         self.draw()
@@ -78,4 +91,8 @@
         self.axes.set_xscale("linear")
         self.axes.set_yscale("linear")
+        self.axes.set_xlabel("Z [$\AA$]")
+        self.axes.set_ylabel("Correlation")
+        self.axes.set_title("Real Space Correlations")
+        self.fig.tight_layout()
 
         if self.data:
@@ -85,5 +102,5 @@
             self.axes.plot(data_idf.x, data_idf.y,
                            label="Interface Distribution Function")
-            self.axes.set_xlim(min(data1.x), max(data1.x) / 4)
+            self.axes.set_xlim(0, max(data1.x) / 4)
             self.axes.legend()
 
@@ -115,5 +132,12 @@
 
         self._canvas = MyMplCanvas(self.model)
-        self.mainVerticalLayout.insertWidget(0, self._canvas)
+        self.plotLayout.insertWidget(0, self._canvas)
+        self.plotLayout.insertWidget(1, NavigationToolbar2QT(self._canvas, self))
+        self._realplot = MyMplCanvas(self.model)
+        self.plotLayout.insertWidget(2, self._realplot)
+        self.plotLayout.insertWidget(3, NavigationToolbar2QT(self._realplot, self))
+
+        self.gridLayout_8.setColumnStretch(0, 1)
+        self.gridLayout_8.setColumnStretch(1, 3)
 
         # Connect buttons to slots.
@@ -238,9 +262,9 @@
         self.model.setItem(W.W_POLY, QtGui.QStandardItem("{:.3g}".format(params['A'])))
         self.model.setItem(W.W_PERIOD, QtGui.QStandardItem("{:.3g}".format(params['max'])))
-        #self._realplot.data = transforms
+        self._realplot.data = transforms
 
         self.update_real_space_plot(transforms)
 
-        #self._realplot.draw_real_space()
+        self._realplot.draw_real_space()
 
     def update_real_space_plot(self, datas):
@@ -358,6 +382,6 @@
         self.cmdTransform.setEnabled(False)
 
-        #self._realplot.data = None
-        #self._realplot.draw_real_space()
+        self._realplot.data = None
+        self._realplot.draw_real_space()
 
     def setClosable(self, value=True):
Index: src/sas/qtgui/Perspectives/Corfunc/UI/CorfuncPanel.ui
===================================================================
--- src/sas/qtgui/Perspectives/Corfunc/UI/CorfuncPanel.ui	(revision cb4d21923d5112d84638455162621f5823dd13c5)
+++ src/sas/qtgui/Perspectives/Corfunc/UI/CorfuncPanel.ui	(revision 85503bc79390fd912c1a1b6baaa305faf2d84000)
@@ -18,17 +18,4 @@
     <layout class="QVBoxLayout" name="mainVerticalLayout">
      <item>
-      <spacer name="verticalSpacer">
-       <property name="orientation">
-        <enum>Qt::Vertical</enum>
-       </property>
-       <property name="sizeHint" stdset="0">
-        <size>
-         <width>20</width>
-         <height>38</height>
-        </size>
-       </property>
-      </spacer>
-     </item>
-     <item>
       <widget class="QGroupBox" name="groupBox">
        <property name="title">
@@ -322,5 +309,12 @@
           </item>
           <item row="0" column="1">
-           <widget class="QLineEdit" name="txtLongPeriod"/>
+           <widget class="QLineEdit" name="txtLongPeriod" width="50">
+	     <property name="minimumSize" stdset="0">
+	       <size>
+		 <width>60</width>
+		 <height>20</height>
+	       </size>
+	     </property>
+	   </widget>
           </item>
           <item row="0" column="2">
@@ -332,5 +326,12 @@
           </item>
           <item row="0" column="3">
-           <widget class="QLineEdit" name="txtAvgIntThick"/>
+           <widget class="QLineEdit" name="txtAvgIntThick">
+	     <property name="minimumSize" stdset="0">
+	       <size>
+		 <width>60</width>
+		 <height>20</height>
+	       </size>
+	     </property>
+	   </widget>
           </item>
           <item row="1" column="0">
@@ -417,4 +418,21 @@
       </layout>
      </item>
+     <item>
+	<spacer name="verticalSpacer">
+	<property name="orientation">
+	    <enum>Qt::Vertical</enum>
+	</property>
+	<property name="sizeHint" stdset="0">
+	    <size>
+	    <width>20</width>
+	    <height>38</height>
+	    </size>
+	</property>
+	</spacer>
+     </item>
+    </layout>
+   </item>
+   <item row="0" column="1">
+    <layout class="QVBoxLayout" name="plotLayout">
     </layout>
    </item>