Index: doc/ref/gpu/gpu_computations.rst
===================================================================
--- doc/ref/gpu/gpu_computations.rst	(revision 066f296ec42ad3f4c6e34e5bec05e4cfb44cf3e4)
+++ doc/ref/gpu/gpu_computations.rst	(revision 711f17e515fff416ab1aa15ae93c3d245ff21525)
@@ -8,6 +8,6 @@
 
 To run on the GPU, your computer must have OpenCL drivers installed.
-For information about OpenCL installation see the
-:ref:`opencl-installation` documentation
+For information about OpenCL installation see this
+:ref:`opencl-installation` guidance.
 
 Where the model is evaluated is a little bit complicated.
@@ -16,26 +16,30 @@
 on the CPU.  If the OpenCL driver is not available for the CPU then
 it will run as a normal program on the CPU.
+
 For models with a large number of parameters or with a lot of code,
 the GPU may be too small to run the program effectively.
 In this case, you should try simplifying the model, maybe breaking it
-into several different models so that you don't need if statements in your code.
+into several different modules so that you don't need *IF* statements in your code.
 If it is still too big, you can set *opencl=False* in the model file and
 the model will only run as a normal program on the CPU.
 This will not usually be necessary.
 
+Device Selection
+................
 If you have multiple GPU devices you can tell SasView which device to use.
 By default, SasView looks for one GPU and one CPU device
 from available OpenCL platforms.
 
-It prefers AMD or NVIDIA drivers for GPU, and prefers Intel or
-Apple drivers for CPU.
-Both GPU and CPU are included on the assumption that CPU is always available
-and supports double precision.
+SasView prefers AMD or NVIDIA drivers for GPU, and prefers Intel or
+Apple drivers for CPU. Both GPU and CPU are included on the assumption that CPU 
+is always available and supports double precision.
 
 The device order is important: GPU is checked before CPU on the assumption that
 it will be faster. By examining ~/sasview.log you can see which device SasView
 chose to run the model.
+
 If you don't want to use OpenCL, you can set *SAS_OPENCL=None*
 in the environment, and it will only use normal programs.
+
 If you want to use one of the other devices, you can run the following
 from the python console in SasView::
@@ -48,4 +52,6 @@
 Use that value as the value of *SAS_OPENCL*.
 
+Compiler Selection
+..................
 For models run as normal programs, you may need to specify a compiler.
 This is done using the SAS_COMPILER environment variable.
@@ -54,3 +60,7 @@
 TinyCC is provided with SasView so that is the default.
 If you want one of the other compilers, be sure to have it available
-on the path so SasView can find it.
+in your *PATH* so SasView can find it!
+
+
+.. note::
+    This help document was last changed by Steve King, 08Oct2016
Index: doc/ref/gpu/opencl_installation.rst
===================================================================
--- doc/ref/gpu/opencl_installation.rst	(revision 6ae795724ae8ad6ee8d6277d9f2de7215e34a8f0)
+++ doc/ref/gpu/opencl_installation.rst	(revision ec8b9a3e2841d6f1ececef27cda299f684cf8285)
@@ -4,4 +4,5 @@
 OpenCL Installation
 *******************
+*Warning! GPU devices do not in general offer the same level of memory protection as CPU devices. If your code attempts to write outside allocated memory buffers unpredicatable behaviour may result (eg, your video display may freeze, or your system may crash, etc). Do not install OpenCL drivers without first checking for known issues (eg, some computer manufacturers install modified graphics drivers so replacing these may not be a good idea!). If in doubt, seek advice from an IT professional before proceeding further.*
 
 1. Check if you have OpenCL already installed
@@ -9,9 +10,9 @@
 
 Windows
-=========
+.......
     The following instructions are based on
     http://web.engr.oregonstate.edu/~mjb/cs475/DoIHaveOpenCL.pdf
 
-    * Go to: Start -> Control Panel -> Administrative Tools
+    * Go to: Start -> Control Panel -> System & Security -> Administrative Tools
     * Double Click on Computer Managment
     * Click on Device Manager
@@ -23,6 +24,8 @@
 
 Mac OSX
-=========
-    For OSXs higher than 10.6 OpenCL is shipped along with the system.
+.......
+    For OS X operating systems higher than 10.6 OpenCL is shipped along with the system.
+
+    However, OpenCL has had a rocky history on Macs. Apple provide a useful compatibility table at https://support.apple.com/en-us/HT202823
 
 
@@ -31,21 +34,26 @@
 
 Windows
-=========
-    Depeneding on the graphic card on your system, drivers
+.......
+    Depending on the graphic card in your system, drivers
     can be obtained from different sources:
 
-    * Nvidia: https://developer.nvidia.com/opencl
+    * NVIDIA: https://developer.nvidia.com/opencl
     * AMD: http://developer.amd.com/tools-and-sdks/opencl-zone/
 
 Mac OSX
-=========
+.......
     N/A
+	
+	You cannot download OpenCL driver updates for your Mac. They are packaged with the normal quarterly OS X updates from Apple. 
 
 
 .. note::
-    Note that Intel provides an OpenCL drivers for Intel processors:
-    https://software.intel.com/en-us/articles/opencl-drivers
-    This can sometimes make use of special vector instructions across multiple
+    Intel provides OpenCL drivers for Intel processors at     https://software.intel.com/en-us/articles/opencl-drivers 
+    These can sometimes make use of special vector instructions across multiple
     processors, so it is worth installing if the GPU does not support double
     precision. You can install this driver alongside the GPU driver for NVIDIA
     or AMD.
+
+	
+.. note::
+    This help document was last changed by Steve King, 08Oct2016