Index: src/sas/sasgui/perspectives/fitting/basepage.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/basepage.py	(revision a321c52bfed2995c9e4b3f6373d71e431fbce955)
+++ src/sas/sasgui/perspectives/fitting/basepage.py	(revision 063304830c63d7d76004b4507d5846bbb5de0be5)
@@ -1156,48 +1156,36 @@
         self._show_combox_helper()
         # select the current model
-        try:
-            # to support older version
-            category_pos = int(state.categorycombobox)
-        except:
-            state._convert_to_sasmodels()
-            state.categorycombobox = unicode(state.categorycombobox)
-            if state.categorycombobox in self.categorybox.Items:
-                category_pos = self.categorybox.Items.index(
-                    state.categorycombobox)
-            else:
-                # Look in master list for model name (model.lower)
-                category_pos = self.get_cat_combo_box_pos(state)
+        state._convert_to_sasmodels()
+        state.categorycombobox = unicode(state.categorycombobox)
+        if state.categorycombobox in self.categorybox.Items:
+            category_pos = self.categorybox.Items.index(
+                state.categorycombobox)
+        else:
+            # Look in master list for model name (model.lower)
+            category_pos = self.get_cat_combo_box_pos(state)
 
         self.categorybox.Select(category_pos)
         self._show_combox(None)
-        try:
-            # to support older version
-            formfactor_pos = int(state.formfactorcombobox)
-        except:
-            if self.categorybox.GetValue() == 'Customized Models' \
-                    and '[plug-in]' not in state.formfactorcombobox:
-                state.formfactorcombobox = \
-                    '[plug-in] ' + state.formfactorcombobox
-            formfactor_pos = 0
-            for ind_form in range(self.formfactorbox.GetCount()):
-                if self.formfactorbox.GetString(ind_form) == \
-                                                    (state.formfactorcombobox):
-                    formfactor_pos = int(ind_form)
+        if self.categorybox.GetValue() == 'Customized Models' \
+                and '[plug-in]' not in state.formfactorcombobox:
+            state.formfactorcombobox = \
+                '[plug-in] ' + state.formfactorcombobox
+        formfactor_pos = 0
+        for ind_form in range(self.formfactorbox.GetCount()):
+            if self.formfactorbox.GetString(ind_form) == \
+                                                (state.formfactorcombobox):
+                formfactor_pos = int(ind_form)
+                break
+
+        self.formfactorbox.Select(formfactor_pos)
+
+        structfactor_pos = 0
+        if state.structurecombobox is not None:
+            state.structurecombobox = unicode(state.structurecombobox)
+            for ind_struct in range(self.structurebox.GetCount()):
+                if self.structurebox.GetString(ind_struct) == \
+                                                (state.structurecombobox):
+                    structfactor_pos = int(ind_struct)
                     break
-
-        self.formfactorbox.Select(formfactor_pos)
-
-        structfactor_pos = 0
-        try:
-            # to support older version
-            structfactor_pos = int(state.structurecombobox)
-        except:
-            if state.structurecombobox is not None:
-                state.structurecombobox = unicode(state.structurecombobox)
-                for ind_struct in range(self.structurebox.GetCount()):
-                    if self.structurebox.GetString(ind_struct) == \
-                                                    (state.structurecombobox):
-                        structfactor_pos = int(ind_struct)
-                        break
 
         self.structurebox.SetSelection(structfactor_pos)
Index: src/sas/sasgui/perspectives/fitting/pagestate.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/pagestate.py	(revision 9eb8fae3b070335330369c35376914412a97bd39)
+++ src/sas/sasgui/perspectives/fitting/pagestate.py	(revision 063304830c63d7d76004b4507d5846bbb5de0be5)
@@ -392,5 +392,5 @@
                 self.formfactorcombobox = 'hardsphere'
 
-    def param_remap_to_sasmodels_convert(self, params):
+    def param_remap_to_sasmodels_convert(self, params, is_string=False):
         """
         Remaps the parameters for sasmodels conversion
@@ -412,5 +412,8 @@
                 lower[0] = False
                 lower[1] = numpy.nan
-            p[name] = float(value)
+            if is_string:
+                p[name] = str(value)
+            else:
+                p[name] = float(value)
             p[name + ".fittable"] = bool(fittable)
             p[name + ".std"] = float(uncert[1])
@@ -468,19 +471,21 @@
             convert.convert_model(self.formfactorcombobox, params)
         if len(self.str_parameters) > 0:
-            str_p = self.param_remap_to_sasmodels_convert(self.str_parameters)
-            formfactor, str_params = convert.convert_model(formfactor, str_p)
-        else:
-            str_params = None
+            str_pars = self.param_remap_to_sasmodels_convert(
+                self.str_parameters, True)
+            formfactor, str_params = convert.convert_model(
+                self.formfactorcombobox, str_pars)
+            for key, value in str_params.iteritems():
+                params[key] = value
 
         # Only convert if old != new, otherwise all the same
         if formfactor != self.formfactorcombobox or \
                         structurefactor != self.structurecombobox:
+            # Spherical SLD number of layers changed between 3.1.2 and 4.0
+            if self.formfactorcombobox == 'SphericalSLDModel':
+                self.multi_factor += 1
             self.formfactorcombobox = formfactor
             self.structurecombobox = structurefactor
             self.parameters = []
             self.parameters = self.param_remap_from_sasmodels_convert(params)
-            if str_params:
-                self.str_parameters = \
-                    self.param_remap_from_sasmodels_convert(str_params)
 
     def _repr_helper(self, list, rep):