Index: calculatorview/src/sans/perspectives/calculator/aperture_editor.py
===================================================================
--- calculatorview/src/sans/perspectives/calculator/aperture_editor.py	(revision 7d45a560fc54369038cd457bd4c8f382c01d9367)
+++ calculatorview/src/sans/perspectives/calculator/aperture_editor.py	(revision 65722740a392af9e817a994c55cf3df20cc6d5d4)
@@ -3,5 +3,5 @@
 import sys
 from copy import deepcopy
-from DataLoader.loader import Loader
+from sans.dataloader.loader import Loader
 from sans.guiframe.utils import check_float
 
@@ -404,5 +404,5 @@
     loader = Loader()
     # Load data 
-    from DataLoader.data_info import Aperture
+    from sans.dataloader.data_info import Aperture
     ap = Aperture()
     dlg = ApertureDialog(aperture=ap)
Index: calculatorview/src/sans/perspectives/calculator/collimation_editor.py
===================================================================
--- calculatorview/src/sans/perspectives/calculator/collimation_editor.py	(revision 7d45a560fc54369038cd457bd4c8f382c01d9367)
+++ calculatorview/src/sans/perspectives/calculator/collimation_editor.py	(revision 65722740a392af9e817a994c55cf3df20cc6d5d4)
@@ -4,6 +4,6 @@
 import sys
 from copy import deepcopy
-from DataLoader.loader import Loader
-from DataLoader.data_info import Aperture, Collimation
+from sans.dataloader.loader import Loader
+from sans.dataloader.data_info import Aperture, Collimation
 from aperture_editor import ApertureDialog
 
Index: calculatorview/src/sans/perspectives/calculator/console.py
===================================================================
--- calculatorview/src/sans/perspectives/calculator/console.py	(revision 7d45a560fc54369038cd457bd4c8f382c01d9367)
+++ calculatorview/src/sans/perspectives/calculator/console.py	(revision 65722740a392af9e817a994c55cf3df20cc6d5d4)
@@ -4,5 +4,5 @@
 import wx
 import sys
-from DataLoader.loader import Loader
+from sans.dataloader.loader import Loader
 
 _BOX_WIDTH = 60
Index: calculatorview/src/sans/perspectives/calculator/data_editor.py
===================================================================
--- calculatorview/src/sans/perspectives/calculator/data_editor.py	(revision 7d45a560fc54369038cd457bd4c8f382c01d9367)
+++ calculatorview/src/sans/perspectives/calculator/data_editor.py	(revision 65722740a392af9e817a994c55cf3df20cc6d5d4)
@@ -5,9 +5,9 @@
 from copy import deepcopy
 
-from DataLoader.loader import Loader
+from sans.dataloader.loader import Loader
 #from DataLoader.data_info import DataInfo
 #from DataLoader.data_info import  Detector
 #from DataLoader.data_info import Collimation
-from DataLoader.data_info import Data2D
+from sans.dataloader.data_info import Data2D
 from detector_editor import DetectorDialog
 from collimation_editor import CollimationDialog
Index: calculatorview/src/sans/perspectives/calculator/detector_editor.py
===================================================================
--- calculatorview/src/sans/perspectives/calculator/detector_editor.py	(revision 7d45a560fc54369038cd457bd4c8f382c01d9367)
+++ calculatorview/src/sans/perspectives/calculator/detector_editor.py	(revision 65722740a392af9e817a994c55cf3df20cc6d5d4)
@@ -3,5 +3,5 @@
 import sys
 from copy import deepcopy
-from DataLoader.data_info import Detector
+from sans.dataloader.data_info import Detector
 from sans.guiframe.utils import check_float
 
Index: calculatorview/src/sans/perspectives/calculator/load_thread.py
===================================================================
--- calculatorview/src/sans/perspectives/calculator/load_thread.py	(revision 7d45a560fc54369038cd457bd4c8f382c01d9367)
+++ calculatorview/src/sans/perspectives/calculator/load_thread.py	(revision 65722740a392af9e817a994c55cf3df20cc6d5d4)
@@ -5,5 +5,5 @@
 
 from data_util.calcthread import CalcThread
-from DataLoader.loader import Loader
+from sans.dataloader.loader import Loader
         
 
Index: calculatorview/src/sans/perspectives/calculator/sample_editor.py
===================================================================
--- calculatorview/src/sans/perspectives/calculator/sample_editor.py	(revision 7d45a560fc54369038cd457bd4c8f382c01d9367)
+++ calculatorview/src/sans/perspectives/calculator/sample_editor.py	(revision 65722740a392af9e817a994c55cf3df20cc6d5d4)
@@ -546,5 +546,5 @@
 if __name__ == "__main__":
     app = wx.App()
-    from DataLoader.data_info import Sample
+    from sans.dataloader.data_info import Sample
     sample = Sample()
     dlg = SampleDialog(sample=sample)
Index: calculatorview/src/sans/perspectives/calculator/source_editor.py
===================================================================
--- calculatorview/src/sans/perspectives/calculator/source_editor.py	(revision 7d45a560fc54369038cd457bd4c8f382c01d9367)
+++ calculatorview/src/sans/perspectives/calculator/source_editor.py	(revision 65722740a392af9e817a994c55cf3df20cc6d5d4)
@@ -534,5 +534,5 @@
 if __name__ =="__main__":
     app  = wx.App()
-    from DataLoader.data_info import Source
+    from sans.dataloader.data_info import Source
     source = Source()
     dlg = SourceDialog(source=source)