Index: src/sas/sascalc/dataloader/data_info.py
===================================================================
--- src/sas/sascalc/dataloader/data_info.py	(revision 1b82623068ec2fe845989e0a485d44d824e81792)
+++ src/sas/sascalc/dataloader/data_info.py	(revision 79885018e2047aef9517748c8de7eccc28d1305e)
@@ -705,7 +705,15 @@
         raise(TypeError,'This is neither SANS nor SESANS data, what the hell are you doing??')
 
-    def __init__(self, x=None, y=None, lam=None, dx=None, dy=None, dlam=None):
+    def __init__(self, x=None, y=None, dx=None, dy=None, lam=None, dlam=None):
         DataInfo.__init__(self)
-        plottable_1D.__init__(self, x, y, lam, dx, dy, dlam)
+        plottable_1D.__init__(self, x, y, dx, dy,None, None, lam, dlam)
+        if self.lam is None: # This means the lam param was not detected in the data: it's SANS data!
+            x_unit = '1/A'
+            y_unit = '1/cm'
+        elif self.lam is not None: # This means lam was detected (should be an empty ndarray): it's SESANS data!
+            x_unit = 'A'
+            y_unit = 'pol'
+        else: # and if it's neither, you get punished!
+            raise(TypeError,'This is neither SANS nor SESANS data, what the hell are you doing??')
 
     def __str__(self):
Index: src/sas/sascalc/fit/AbstractFitEngine.py
===================================================================
--- src/sas/sascalc/fit/AbstractFitEngine.py	(revision fc18690cd84cc4dd6e33a9d344f47b08cef71290)
+++ src/sas/sascalc/fit/AbstractFitEngine.py	(revision 79885018e2047aef9517748c8de7eccc28d1305e)
@@ -131,5 +131,5 @@
         a way to get residuals from data.
     """
-    def __init__(self, x, y, dx=None, dy=None, smearer=None, data=None):
+    def __init__(self, x, y, dx=None, dy=None, smearer=None, data=None, lam=None, dlam=None):
         """
             :param smearer: is an object of class QSmearer or SlitSmearer
@@ -152,5 +152,5 @@
                 
         """
-        Data1D.__init__(self, x=x, y=y, dx=dx, dy=dy)
+        Data1D.__init__(self, x=x, y=y, dx=dx, dy=dy, lam=lam,dlam=dlam)
         self.num_points = len(x)
         self.sas_data = data
Index: src/sas/sascalc/fit/BumpsFitting.py
===================================================================
--- src/sas/sascalc/fit/BumpsFitting.py	(revision b699768550de9d4b35b087234ec1d2a461922bab)
+++ src/sas/sascalc/fit/BumpsFitting.py	(revision 79885018e2047aef9517748c8de7eccc28d1305e)
@@ -26,5 +26,4 @@
 from bumps import parameter
 from bumps.fitproblem import FitProblem
-
 
 from sas.sascalc.fit.AbstractFitEngine import FitEngine
Index: src/sas/sasgui/guiframe/dataFitting.py
===================================================================
--- src/sas/sasgui/guiframe/dataFitting.py	(revision d85c194ea2f78cb2b9b3de9c969e1b8ebea6b6d2)
+++ src/sas/sasgui/guiframe/dataFitting.py	(revision 79885018e2047aef9517748c8de7eccc28d1305e)
@@ -17,5 +17,5 @@
     """
     """
-    def __init__(self, x=None, y=None, dx=None, dy=None):
+    def __init__(self, x=None, y=None, dx=None, dy=None, lam=None, dlam=None):
         """
         """
@@ -24,6 +24,6 @@
         if y is None:
             y = []
-        PlotData1D.__init__(self, x, y, dx, dy)
-        LoadData1D.__init__(self, x, y, dx, dy)
+        PlotData1D.__init__(self, x, y, lam, dx, dy, dlam)
+        LoadData1D.__init__(self, x, y, lam, dx, dy, dlam)
         self.id = None
         self.list_group_id = []
@@ -68,5 +68,5 @@
         # First, check the data compatibility
         dy, dy_other = self._validity_check(other)
-        result = Data1D(x=[], y=[], dx=None, dy=None)
+        result = Data1D(x=[], y=[], lam=[], dx=None, dy=None, dlam=None)
         result.clone_without_data(length=len(self.x), clone=self)
         result.copy_from_datainfo(data1d=self)
@@ -115,7 +115,11 @@
         # First, check the data compatibility
         self._validity_check_union(other)
-        result = Data1D(x=[], y=[], dx=None, dy=None)
+        result = Data1D(x=[], y=[], lam=[], dx=None, dy=None, dlam=None)
         tot_length = len(self.x) + len(other.x)
         result = self.clone_without_data(length=tot_length, clone=result)
+        if self.dlam == None or other.dlam is None:
+            result.dlam = None
+        else:
+            result.dlam = numpy.zeros(tot_length)
         if self.dy == None or other.dy is None:
             result.dy = None
@@ -141,4 +145,9 @@
         result.y = numpy.append(self.y, other.y)
         result.y = result.y[ind]
+        result.lam = numpy.append(self.lam, other.lam)
+        result.lam = result.lam[ind]
+        if result.dlam != None:
+            result.dlam = numpy.append(self.dlam, other.dlam)
+            result.dlam = result.dlam[ind]
         if result.dy != None:
             result.dy = numpy.append(self.dy, other.dy)
@@ -260,7 +269,11 @@
         # First, check the data compatibility
         self._validity_check_union(other)
-        result = Data1D(x=[], y=[], dx=None, dy=None)
+        result = Data1D(x=[], y=[], lam=[], dx=None, dy=None, dlam=[])
         tot_length = len(self.x)+len(other.x)
         result.clone_without_data(length=tot_length, clone=self)
+        if self.dlam == None or other.dlam is None:
+            result.dlam = None
+        else:
+            result.dlam = numpy.zeros(tot_length)
         if self.dy == None or other.dy is None:
             result.dy = None
@@ -285,4 +298,6 @@
         result.y = numpy.append(self.y, other.y)
         result.y = result.y[ind]
+        result.lam = numpy.append(self.lam, other.lam)
+        result.lam = result.lam[ind]
         if result.dy != None:
             result.dy = numpy.append(self.dy, other.dy)
Index: src/sas/sasgui/perspectives/fitting/basepage.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/basepage.py	(revision 6df015de019813c258c44d7e00fec9ab5a313bd9)
+++ src/sas/sasgui/perspectives/fitting/basepage.py	(revision 79885018e2047aef9517748c8de7eccc28d1305e)
@@ -282,6 +282,8 @@
                            num=self.npts_x, endpoint=True)
         self.data = Data1D(x=x)
-        self.data.xaxis('\\rm{Q}', "A^{-1}")
-        self.data.yaxis('\\rm{Intensity}', "cm^{-1}")
+        #self.data.xaxis('\\rm{Q}', "A^{-1}")
+        self.data.xaxis('\\rm{X}', "")
+        #self.data.yaxis('\\rm{Intensity}', "cm^{-1}")
+        self.data.yaxis('\\rm{Y}', "")
         self.data.is_data = False
         self.data.id = str(self.uid) + " data"
@@ -308,6 +310,8 @@
                            num=self.npts_x, endpoint=True, base=10.0)
         self.data = Data1D(x=x)
-        self.data.xaxis('\\rm{Q}', "A^{-1}")
-        self.data.yaxis('\\rm{Intensity}', "cm^{-1}")
+        #self.data.xaxis('\\rm{Q}', "A^{-1}")
+        #self.data.yaxis('\\rm{Intensity}', "cm^{-1}")
+        self.data.xaxis('\\rm{X}', "")
+        self.data.yaxis('\\rm{Y}', "")
         self.data.is_data = False
         self.data.id = str(self.uid) + " data"
Index: src/sas/sasgui/perspectives/fitting/fitpage.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/fitpage.py	(revision 6df015de019813c258c44d7e00fec9ab5a313bd9)
+++ src/sas/sasgui/perspectives/fitting/fitpage.py	(revision 79885018e2047aef9517748c8de7eccc28d1305e)
@@ -98,5 +98,5 @@
     def onTrafo(self, event):
         """
-        On Weighting radio button event, sets the weightbt_string
+        On Trafo radio button event, sets the Trafobt_string
         """
         self.Trafobt_string = event.GetEventObject().GetLabelText()
@@ -120,14 +120,15 @@
         self.no_transform = wx.RadioButton(self, wx.ID_ANY,
                                                   'None', style=wx.RB_GROUP)
-        self.Bind(wx.EVT_RADIOBUTTON, self.onTrafo,
-                          id=self.no_transform.GetId())
+
+        #self.Bind(wx.EVT_RADIOBUTTON, self.onTrafo,
+         #                 id=self.no_transform.GetId())
         self.hankel = wx.RadioButton(self, wx.ID_ANY,
                                                   'Hankel')
-        self.Bind(wx.EVT_RADIOBUTTON, self.onTrafo,
-                          id=self.hankel.GetId())
+        #self.Bind(wx.EVT_RADIOBUTTON, self.onTrafo,
+        #                  id=self.hankel.GetId())
         self.cosine = wx.RadioButton(self, wx.ID_ANY,
                                                   'Cosine')
-        self.Bind(wx.EVT_RADIOBUTTON, self.onTrafo,
-                          id=self.cosine.GetId())
+        #self.Bind(wx.EVT_RADIOBUTTON, self.onTrafo,
+         #                 id=self.cosine.GetId())
 
         #Not sure about this (only once though)
Index: src/sas/sasgui/plottools/plottables.py
===================================================================
--- src/sas/sasgui/plottools/plottables.py	(revision 8abd96d6ebdf20551265a5a33a9fd0d56ebe5584)
+++ src/sas/sasgui/plottools/plottables.py	(revision 79885018e2047aef9517748c8de7eccc28d1305e)
@@ -1022,5 +1022,5 @@
     """
 
-    def __init__(self, x, y, dx=None, dy=None):
+    def __init__(self, x, y, lam=None, dx=None, dy=None, dlam=None):
         """
         Draw points specified by x[i],y[i] in the current color/symbol.
@@ -1036,6 +1036,8 @@
         self.x = x
         self.y = y
+        self.lam = lam
         self.dx = dx
         self.dy = dy
+        self.dlam = dlam
         self.source = None
         self.detector = None